<template>
    <q-page class="bg-base">
        <DocumentWrapper ref="wrap">
            <ListPage :desktop="4" class="q-pa-lg" v-if="$q.screen.lg">
                <ProjectFullCard :project="project" @submit="loadProject" @delete="loadProject"/>
            </ListPage>
            <ProjectMobile v-else :project="project" @submit="loadProject" @delete="loadProject"/>

        </DocumentWrapper>
    </q-page>
</template>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import {ProjectResponse} from "src/classLibrary/APIModels/core/projectResponse";
import ProjectFullCard from "components/Full/ProjectFullCard.vue";
import ListPage from "components/Core/ListPage.vue";
import AddUserToProjectDialog from "components/Dialog/AddUserToProjectDialog.vue";
import ProjectMobile from "components/Full/ProjectMobile.vue";

@Component({
    components: {ProjectMobile, AddUserToProjectDialog, ListPage, ProjectFullCard, DocumentWrapper}
})
export default class Project extends Vue {
    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    project: ProjectResponse | null = null

    async loadProject() {
        const token = await this.$auth.CoreToken;
        const pid = this.PersistentStore.StoreValue.project;
        const r = await this.$coreApi.Get<ProjectResponse>(`Project/${pid}`, null, token);
        if (r.isErr()) {
            return this.Wrap.SubmitError(r.unwrapErr())
        }
        this.project = r.unwrap();
    }

    created() {
        this.loadProject();
    }
}
</script>

<style lang='scss' scoped>

</style>
